This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1258160 - Review Request: nodejs-sinon - Test spies, stubs and mocks for JavaScript
Review Request: nodejs-sinon - Test spies, stubs and mocks for JavaScript
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Hughes
Fedora Extras Quality Assurance
:
Depends On: 1258156 1258157 1258159
Blocks: nodejs-reviews 1258222
  Show dependency treegraph
 
Reported: 2015-08-29 14:02 EDT by Piotr Popieluch
Modified: 2015-10-31 22:37 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-23 13:19:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tom: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Piotr Popieluch 2015-08-29 14:02:42 EDT
Spec URL: https://piotrp.fedorapeople.org/nodejs-sinon.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-sinon-1.16.1-1.fc22.src.rpm
Description: Test spies, stubs and mocks for JavaScript
Fedora Account System Username: piotrp
Comment 1 Tom Hughes 2015-10-06 14:25:49 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Sources used to build the package match the upstream source, as provided
  in the spec URL.
  Note: Upstream MD5sum check error, diff is in /home/tom/1258160-nodejs-
  sinon/diff.txt
  See: http://fedoraproject.org/wiki/Packaging/SourceURL


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 56 files have unknown license. Detailed
     output of licensecheck in /home/tom/1258160-nodejs-
     sinon/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-sinon-1.16.1-1.fc24.noarch.rpm
          nodejs-sinon-1.16.1-1.fc24.src.rpm
nodejs-sinon.noarch: W: only-non-binary-in-usr-lib
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/lolex /usr/lib/node_modules/lolex
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/util /usr/lib/node_modules/util
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/samsam /usr/lib/node_modules/samsam
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/formatio /usr/lib/node_modules/formatio
nodejs-sinon.src: W: file-size-mismatch Sinon.JS-38799cceb076a8190f60a41da234dcef0292ef64.tar.gz = 105436, https://github.com/cjohansen/Sinon.JS/archive/38799cceb076a8190f60a41da234dcef0292ef64/Sinon.JS-38799cceb076a8190f60a41da234dcef0292ef64.tar.gz = 105417
2 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-sinon.noarch: W: only-non-binary-in-usr-lib
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/formatio /usr/lib/node_modules/formatio
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/lolex /usr/lib/node_modules/lolex
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/samsam /usr/lib/node_modules/samsam
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/util /usr/lib/node_modules/util
1 packages and 0 specfiles checked; 0 errors, 5 warnings.



Requires
--------
nodejs-sinon (rpmlib, GLIBC filtered):
    nodejs(engine)
    npm(formatio)
    npm(lolex)
    npm(samsam)
    npm(util)



Provides
--------
nodejs-sinon:
    nodejs-sinon
    npm(sinon)



Source checksums
----------------
https://github.com/cjohansen/Sinon.JS/archive/38799cceb076a8190f60a41da234dcef0292ef64/Sinon.JS-38799cceb076a8190f60a41da234dcef0292ef64.tar.gz :
  CHECKSUM(SHA256) this package     : 0396dfdf61d45031beb93f5cfe4eab31b0de3f00cc717ddb6ba8eaeb8d658544
  CHECKSUM(SHA256) upstream package : 7ae135dcf484153b53b509d0e129022feb52568f51cf4dbae18c30525460579c
diff -r also reports differences


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1258160
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Tom Hughes 2015-10-06 14:29:04 EDT
Needs updating to 1.17.1 upstream release and there are some BRs missing for running the tests, namely:

npm(formatio)
npm(lolex)
npm(samsam)
npm(util)

Even with those, and the unpackaged ones installed via npm, the tests are failing with:

Failed loading configuration: 'node_modules/lolex/lolex.js' matched no files or resources

Our packaged lolex has src/lolex.js but no lolex.js in the root, possibly because that was a browserified version that we decided not to include? If that is the case then it either needs to be linked to the root in the lolex package or this one needs patching to find it.
Comment 3 Piotr Popieluch 2015-10-07 14:22:41 EDT
I think the buster tests actually try to test the browser code not the nodejs. The tests explicitly load the browserified lolex version.

I will need some more time to sort this out.
Comment 4 Piotr Popieluch 2015-10-10 15:12:27 EDT
I think the only relevant test is:
./node_modules/buster/bin/buster-test --config-group node
Other tests do browser tests and coverage.

Unfortunately this one fails on 3 out of 1169 tests. I don't know why.

I've packaged this almost a year ago because many of my other nodejs packages required this as BR. I've used this for local testing but only recently figured it would be useful to get it in Fedora. 

- Update to newer version
- added missing BR
- update test seciont
Spec URL: https://piotrp.fedorapeople.org/nodejs-sinon.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-sinon-1.17.1-1.fc22.src.rpm
Comment 5 Tom Hughes 2015-10-11 07:22:06 EDT
That is actually 1.17.0 by the looks of it, but 1.17.1 seems to be missing from the github repo?
Comment 6 Piotr Popieluch 2015-10-12 02:43:17 EDT
I'm sorry, I mixed up. Latest release is 1.17.0. 

Spec URL: https://piotrp.fedorapeople.org/nodejs-sinon.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-sinon-1.17.0-1.fc22.src.rpm
Comment 7 Tom Hughes 2015-10-12 03:19:59 EDT
Well no, npmjs.org does have 1.17.1 and I just realised it is in the github repo but on a branch and they forgot to tag it. The correct git hash is d5512942fa64d3775760af3cfb22cdd297fca38c I think: 

https://github.com/sinonjs/sinon/commit/d5512942fa64d3775760af3cfb22cdd297fca38c
Comment 8 Piotr Popieluch 2015-10-13 02:55:13 EDT
Thanks for finding that. Updated to 1.17.1 with correct hash now. Now only one test fails.

Spec URL: https://piotrp.fedorapeople.org/nodejs-sinon.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-sinon-1.17.1-1.fc22.src.rpm
Comment 9 Tom Hughes 2015-10-13 14:16:59 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 58 files have unknown license. Detailed
     output of licensecheck in /home/tom/1258160-nodejs-
     sinon/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.13 starting (python version = 3.4.2)...
Start: init plugins
INFO: selinux disabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.13
INFO: Mock Version: 1.2.13
Finish: chroot init
INFO: installing package(s): /home/tom/1258160-nodejs-sinon/results/nodejs-sinon-1.17.1-1.fc24.noarch.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/compton-rawhide-x86_64/root/ --releasever 24 install /home/tom/1258160-nodejs-sinon/results/nodejs-sinon-1.17.1-1.fc24.noarch.rpm


Rpmlint
-------
Checking: nodejs-sinon-1.17.1-1.fc24.noarch.rpm
          nodejs-sinon-1.17.1-1.fc24.src.rpm
nodejs-sinon.noarch: W: only-non-binary-in-usr-lib
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/lolex /usr/lib/node_modules/lolex
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/util /usr/lib/node_modules/util
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/samsam /usr/lib/node_modules/samsam
nodejs-sinon.noarch: W: dangling-symlink /usr/lib/node_modules/sinon/node_modules/formatio /usr/lib/node_modules/formatio
2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Requires
--------
nodejs-sinon (rpmlib, GLIBC filtered):
    nodejs(engine)
    npm(formatio)
    npm(lolex)
    npm(samsam)
    npm(util)



Provides
--------
nodejs-sinon:
    nodejs-sinon
    npm(sinon)



Source checksums
----------------
https://github.com/cjohansen/Sinon.JS/archive/de6b53476dbcee95a366b719c0098af86a05d867/Sinon.JS-de6b53476dbcee95a366b719c0098af86a05d867.tar.gz :
  CHECKSUM(SHA256) this package     : 7f0107fcd41c2844b395c97c976ba74527caa732ebfdda087a30d03479909890
  CHECKSUM(SHA256) upstream package : 7f0107fcd41c2844b395c97c976ba74527caa732ebfdda087a30d03479909890


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1258160
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 10 Tom Hughes 2015-10-13 14:18:42 EDT
The test failure is because we have formatio 1.1.2 not 1.1.1 and that includes https://github.com/busterjs/formatio/commit/116d0ace0103b21436e448091bb0fad9b46eb8c5 which makes the "(empty string)" appear. So I think we can ignore that.

The only other problem is that you need to fixdep lolex as we only have 1.3.1 and this ias asking for 1.3.2 so it won't install.
Comment 11 Piotr Popieluch 2015-10-13 15:15:58 EDT
Ok thank you, 

I've added the fixdep on lolex, uploaded file, didn't bump release number.

ps. also added release-monitoring for lolex and working on update.
Comment 12 Tom Hughes 2015-10-13 15:22:26 EDT
Great. Package approved then.
Comment 13 Piotr Popieluch 2015-10-13 15:23:43 EDT
Thanks
Comment 14 Fedora Update System 2015-10-14 15:53:09 EDT
nodejs-sinon-1.17.1-1.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-f637b4b4c0
Comment 15 Fedora Update System 2015-10-14 15:54:15 EDT
nodejs-sinon-1.17.1-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-4741c1fced
Comment 16 Fedora Update System 2015-10-14 18:51:59 EDT
nodejs-sinon-1.17.1-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update nodejs-sinon'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-4741c1fced
Comment 17 Fedora Update System 2015-10-15 01:51:34 EDT
nodejs-sinon-1.17.1-1.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update nodejs-sinon'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-f637b4b4c0
Comment 18 Fedora Update System 2015-10-23 13:19:14 EDT
nodejs-sinon-1.17.1-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 19 Fedora Update System 2015-10-31 22:37:12 EDT
nodejs-sinon-1.17.1-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.